<script>
import SaveBtn from "@components/utils/save-btn";
import Multiselect from "vue-multiselect";
import moment from "moment";
moment.locale('fr');

export default {
  name: "agenda",
  components: { SaveBtn, Multiselect },
  props : {
    title : '',
    meeting : null,
    update_case : false
  },
  data() {
    return {
      spokesPersons : []
    }
  },
  mounted() {
    this.loadSpokesPersons()
  },
  methods : {
    async submit() {
      this.$bvModal.hide('modal-event')
      this.meeting.end_at = moment(this.meeting.end_at).format('YYYY-MM-DD HH:mm:ss')
      this.meeting.start_at = moment(this.meeting.start_at).format('YYYY-MM-DD HH:mm:ss')
      let message;
      if(this.update_case){
        message = await this.$store.dispatch('meeting/update', { id : this.meeting.id, meeting : this.meeting })
      }else{
        message = await this.$store.dispatch('meeting/create', { meeting: this.meeting })
      }
      this.$bvToast.toast(message, {title: 'Succès'});
      this.$emit('reloadMeetings')
    },
    async remove( meeting ) {
      const message = await this.$store.dispatch('meeting/delete', {id: meeting.id})
      this.$bvToast.toast(message, {title: 'Succès'});
      this.$emit('reloadMeetings')
      this.$bvModal.hide('modal-event')
    },
    async loadSpokesPersons() {
      const response = await this.$store.dispatch('message/spokespersons')
      this.spokesPersons = response.map(el => el.user);
    },
  }
}
</script>

<template>
  <b-modal id="modal-event" size="xl" :title="title" centered hide-footer>
    <form @submit.prevent="submit">
      <div class="row">
        <div class="col-md-4">
          <b-form-group label="Titre du rendez-vous">
            <b-form-input v-model="meeting.title" required></b-form-input>
          </b-form-group>
          <b-form-group label="Description">
            <b-form-textarea v-model="meeting.description"></b-form-textarea>
          </b-form-group>
          <b-form-group label="Participants">
            <multiselect
              multiple
              v-model="meeting.participants"
              track-by="fullname"
              :options="spokesPersons"
              placeholder="Choisir des participants"
              label="fullname"
              selectLabel="Choisir"
              selectedLabel="Invité"
              deselectLabel="Retirer"
            >
              <template v-slot:noOptions>
                Pas de participant à inviter
              </template>
            </multiselect>
          </b-form-group>
        </div>
        <div class="col-md-8">
          <div class="row">
            <b-form-group class="ml-3" label="Date de début">
              <v-date-picker v-model="meeting.start_at" required mode="dateTime" is24hr />
            </b-form-group>
            <b-form-group class="ml-3" label="Date de fin">
              <v-date-picker v-model="meeting.end_at" required mode="dateTime" is24hr />
            </b-form-group>
          </div>
        </div>
      </div>
      <b-button v-if="update_case" @click="remove(meeting)" type="button" class="float-left btn btn-danger">Supprimer</b-button>
      <save-btn></save-btn>
    </form>
  </b-modal>
</template>
